DemuxInputStream (Apache Ant API)
Date: 2015-06-29

org.apache.tools.ant

## Class DemuxInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.tools.ant.DemuxInputStream

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class DemuxInputStream
      extends java.io.InputStream

  Passes input requests to the project object for demuxing into individual tasks and threads.
  Since:
    Ant 1.6

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DemuxInputStream(Project project)` Create a DemuxInputStream for the given project

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `read()` Read a byte from the project's demuxed input.
    `int` | `read(byte[] buffer, int offset, int length)` Read bytes from the project's demuxed input.

    - ### Methods inherited from class java.io.InputStream

      `available, close, mark, markSupported, read, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DemuxInputStream

          public DemuxInputStream(Project project)

      Create a DemuxInputStream for the given project
      Parameters:
        `project` - the project instance

  - ### Method Detail

    - #### read

          public int read()
                   throws java.io.IOException

      Read a byte from the project's demuxed input.
      Specified by:
        `read` in class `java.io.InputStream`
      Returns:
        the next byte
      Throws:
        `java.io.IOException` - on error

    - #### read

          public int read(byte[] buffer,
                 int offset,
                 int length)
                   throws java.io.IOException

      Read bytes from the project's demuxed input.
      Overrides:
        `read` in class `java.io.InputStream`
      Parameters:
        `buffer` - an array of bytes to read into
        `offset` - the offset in the array of bytes
        `length` - the number of bytes in the array
      Returns:
        the number of bytes read
      Throws:
        `java.io.IOException` - on error